import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;

public class Main {

	private static int NosExpandidos = 1;

	private static LinkedList listaTemporaria = new LinkedList();

	public static void main(String[] args) {

		Nodo nodo = new Nodo();
		nodo = embaralhar(nodo, 16);
		System.out.println("Estado Inicial");
		imprime(nodo);
		// BuscaEmProfundidade(nodo, 1);
		// BuscaEmProfundidadeComBacktracking(nodo, 1, 15);
		// BuscaEmLargura(nodo);
		// BuscaEstrelaHeuristicaNumPecasForaLugar(nodo);
		// BuscaEstrelaHeuristicaDistManhattan(nodo);
		 BuscaEstrelaHeuristicaDistManhattanComVerificacaoDosCantos(nodo);
	}

	private static void BuscaEstrelaHeuristicaDistManhattanComVerificacaoDosCantos(
			Nodo raiz) {
		try {
			LinkedList fila = new LinkedList();
			fila.add(raiz);
			Nodo nodoTemp = null;
			LinkedList nodosJahVisitados = new LinkedList();
			nodosJahVisitados.add(raiz);
			while (fila.size() > 0) {
				Iterator iterator = fila.iterator();
				int custo = 100000;
				Nodo nodoCandidato = null;
				while (iterator.hasNext()) {
					nodoTemp = (Nodo) iterator.next();
					if (nodoTemp
							.getHeuristicaDistManhattanComVerificacaoDeCantos() < custo) {
						custo = nodoTemp
								.getHeuristicaDistManhattanComVerificacaoDeCantos();
						nodoCandidato = nodoTemp;
					}
				}
				if (fila.remove(nodoCandidato)) {
					if (nodoCandidato.isResolvido()) {
						// imprime caminho percorrido...
						System.out
								.println("Soluo encontrada aps pesquisa em "
										+ NosExpandidos + " nodos");
						imprimeCaminho(nodoCandidato);
						System.exit(0);
					} else {
						// adiciona filhos a lista...
						Nodo filhos[] = new Nodo[nodoCandidato.getQtdeFilhos()];
						filhos = nodoCandidato.getFilhos();
						for (int i = 0; i < nodoCandidato.getQtdeFilhos(); i++) {
							// System.out.println("Nmero de ns expandidos at
							// agora: "+NosExpandidos);
							// imprime(filhos[i]);
							NosExpandidos++;
							// somente inclui se no for movimento repetido
							// ou seja, verifica a lista de novos j visitados
							// antes
							Iterator iterator2 = nodosJahVisitados.iterator();
							boolean podeIncluir = true;
							while (iterator2.hasNext()) {
								nodoTemp = (Nodo) iterator2.next();
								if ((filhos[i].equals(nodoTemp))) {
									podeIncluir = false;
								}
							}
							if (podeIncluir) {
								fila.add(filhos[i]);
								// System.out.println("filho:");
								// imprime(filhos[i]);
							}
						}
						nodosJahVisitados.add(nodoCandidato);
					}
				} else {
					throw new Exception(
							"Nodo foi escolhido mas nao pode ser retirado da lista...");
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static void BuscaEstrelaHeuristicaDistManhattan(Nodo raiz) {
		try {
			LinkedList fila = new LinkedList();
			fila.add(raiz);
			Nodo nodoTemp = null;
			LinkedList nodosJahVisitados = new LinkedList();
			nodosJahVisitados.add(raiz);
			while (fila.size() > 0) {
				Iterator iterator = fila.iterator();
				int custo = 100000;
				Nodo nodoCandidato = null;
				while (iterator.hasNext()) {
					nodoTemp = (Nodo) iterator.next();
					if (nodoTemp.getHeuristicaDistManhattan() < custo) {
						custo = nodoTemp.getHeuristicaDistManhattan();
						nodoCandidato = nodoTemp;
					}
				}
				if (fila.remove(nodoCandidato)) {
					if (nodoCandidato.isResolvido()) {
						// imprime caminho percorrido...
						System.out
								.println("Soluo encontrada aps pesquisa em "
										+ NosExpandidos + " nodos");
						imprimeCaminho(nodoCandidato);
						System.exit(0);
					} else {
						// adiciona filhos a lista...
						Nodo filhos[] = new Nodo[nodoCandidato.getQtdeFilhos()];
						filhos = nodoCandidato.getFilhos();
						for (int i = 0; i < nodoCandidato.getQtdeFilhos(); i++) {
							// System.out.println("Nmero de ns expandidos at
							// agora: "+NosExpandidos);
							// imprime(filhos[i]);
							NosExpandidos++;
							// somente inclui se no for movimento repetido
							// ou seja, verifica a lista de novos j visitados
							// antes
							Iterator iterator2 = nodosJahVisitados.iterator();
							boolean podeIncluir = true;
							while (iterator2.hasNext()) {
								nodoTemp = (Nodo) iterator2.next();
								if ((filhos[i].equals(nodoTemp))) {
									podeIncluir = false;
								}
							}
							if (podeIncluir) {
								fila.add(filhos[i]);
								// System.out.println("filho:");
								// imprime(filhos[i]);
							}
						}
						nodosJahVisitados.add(nodoCandidato);
					}
				} else {
					throw new Exception(
							"Nodo foi escolhido mas nao pode ser retirado da lista...");
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static void BuscaEstrelaHeuristicaNumPecasForaLugar(Nodo raiz) {
		try {
			LinkedList fila = new LinkedList();
			fila.add(raiz);
			Nodo nodoTemp = null;
			LinkedList nodosJahVisitados = new LinkedList();
			nodosJahVisitados.add(raiz);
			while (fila.size() > 0) {
				Iterator iterator = fila.iterator();
				int custo = 100000;
				Nodo nodoCandidato = null;
				while (iterator.hasNext()) {
					nodoTemp = (Nodo) iterator.next();
					if (nodoTemp.getHeuristicaNumPecasForaLugar() < custo) {
						custo = nodoTemp.getHeuristicaNumPecasForaLugar();
						nodoCandidato = nodoTemp;
					}
				}
				if (fila.remove(nodoCandidato)) {
					if (nodoCandidato.isResolvido()) {
						// imprime caminho percorrido...
						System.out
								.println("Soluo encontrada aps pesquisa em "
										+ NosExpandidos + " nodos");
						imprimeCaminho(nodoCandidato);
						System.exit(0);
					} else {
						// adiciona filhos a lista...
						Nodo filhos[] = new Nodo[nodoCandidato.getQtdeFilhos()];
						filhos = nodoCandidato.getFilhos();
						for (int i = 0; i < nodoCandidato.getQtdeFilhos(); i++) {
							// System.out.println("Nmero de ns expandidos at
							// agora: "+NosExpandidos);
							// imprime(filhos[i]);
							NosExpandidos++;
							// somente inclui se no for movimento repetido
							// ou seja, verifica a lista de novos j visitados
							// antes
							Iterator iterator2 = nodosJahVisitados.iterator();
							boolean podeIncluir = true;
							while (iterator2.hasNext()) {
								nodoTemp = (Nodo) iterator2.next();
								if ((filhos[i].equals(nodoTemp))) {
									podeIncluir = false;
								}
							}
							if (podeIncluir) {
								fila.add(filhos[i]);
								// System.out.println("filho:");
								// imprime(filhos[i]);
							}
						}
						nodosJahVisitados.add(nodoCandidato);
					}
				} else {
					throw new Exception(
							"Nodo foi escolhido mas nao pode ser retirado da lista...");
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static void BuscaEmLargura(Nodo raiz) {
		LinkedList fila = new LinkedList();
		LinkedList nodosJahVisitados = new LinkedList();
		fila.add(raiz);
		Nodo nodoTemp = null;
		while (fila.size() > 0) {
			// verifica se no  o nodo com a solucao.
			nodoTemp = (Nodo) fila.removeFirst();
			nodosJahVisitados.add(nodoTemp);

			if (nodoTemp.isResolvido()) {
				// imprime caminho percorrido...
				System.out.println("Soluo encontrada aps pesquisa em "
						+ NosExpandidos + " nodos");
				imprimeCaminho(nodoTemp);
				System.exit(0);
			} else {
				// adiciona filhos a lista...
				Nodo filhos[] = new Nodo[nodoTemp.getQtdeFilhos()];
				filhos = nodoTemp.getFilhos();
				for (int i = 0; i < nodoTemp.getQtdeFilhos(); i++) {
					// System.out.println("Nmero de ns expandidos at agora:"+NosExpandidos);
					// imprime(filhos[i]);
					Iterator iterator2 = nodosJahVisitados.iterator();
					boolean podeIncluir = true;
					Nodo no_temporario = null;
					while (iterator2.hasNext()) {
						no_temporario = (Nodo) iterator2.next();
						if ((filhos[i].equals(no_temporario))) {
							podeIncluir = false;
						}
					}
					if (podeIncluir) {
						fila.add(filhos[i]);
						NosExpandidos++;
					}
				}
			}
		}
	}

	private static void BuscaEmProfundidadeComBacktracking(Nodo nodo,
			int nivelDaArvore, int backtracking) {
		listaTemporaria.add(nodo);
		if (nodo.isResolvido()) {
			System.out.println("Soluo encontrada no nvel " + nivelDaArvore);
			System.out.println("Soluo encontrada aps pesquisa em "
					+ NosExpandidos + " nodos");
			// imprime caminho percorrido...
			imprimeCaminho(nodo);
			System.exit(0);
		} else if ((!nodo.isResolvido()) && nodo.getQtdeFilhos() > 0
				&& nivelDaArvore <= backtracking) {
			// System.out.println("Arvore de busca no nvel: "+(nivelDaArvore));
			Nodo filhos[] = new Nodo[nodo.getQtdeFilhos()];
			filhos = nodo.getFilhos();
			// retira estados repetidos verificando a listaTemporaria global...
			Iterator iterator = listaTemporaria.iterator();
			while (iterator.hasNext()) {
				Nodo nodoTemp = (Nodo) iterator.next();
				for (int i = 0; i < nodo.getQtdeFilhos(); i++) {
					if (filhos[i] != null && filhos[i].equals(nodoTemp)) {
						filhos[i] = null;
					}
				}
			}
			for (int i = 0; i < nodo.getQtdeFilhos(); i++) {
				if (filhos[i] != null) {
					// System.out.println("Ns expandidos: "
					// + NosExpandidos +" Nvel da Arvore: " +nivelDaArvore);
					// imprime(filhos[i]);
					NosExpandidos++;
					BuscaEmProfundidadeComBacktracking(filhos[i],
							nivelDaArvore + 1, backtracking);
				}
			}
		}
	}

	private static void BuscaEmProfundidade(Nodo nodo, int nivelDaArvore) {
		listaTemporaria.add(nodo);
		if (nodo.isResolvido()) {
			System.out.println("Soluo encontrada no nvel " + nivelDaArvore);
			System.out.println("Soluo encontrada aps pesquisa em "
					+ NosExpandidos + " nodos");
			System.out.println("Caminho de volta...");
			imprimeCaminho(nodo);
			System.exit(0);
		} else if ((!nodo.isResolvido()) && nodo.getQtdeFilhos() > 0) {
			System.out.println("Arvore de busca no nvel: " + (nivelDaArvore));
			Nodo filhos[] = new Nodo[nodo.getQtdeFilhos()];
			filhos = nodo.getFilhos();
			// retira estados repetidos verificando a listaTemporaria global...
			Iterator iterator = listaTemporaria.iterator();
			while (iterator.hasNext()) {
				Nodo nodoTemp = (Nodo) iterator.next();
				for (int i = 0; i < nodo.getQtdeFilhos(); i++) {
					if (filhos[i] != null && filhos[i].equals(nodoTemp)) {
						filhos[i] = null;
					}
				}
			}
			for (int i = 0; i < nodo.getQtdeFilhos(); i++) {
				if (filhos[i] != null) {
					System.out.println("Nmero de ns expandidos at agora: "
							+ NosExpandidos++);
					imprime(filhos[i]);
					BuscaEmProfundidade(filhos[i], nivelDaArvore + 1);
				}
			}
		}
	}

	private static Nodo embaralhar(Nodo nodo, int nJogadas) {
		System.out.println("----Para embaralhar ser retornado " + nJogadas
				+ " jogadas----");
		int temp = 0;
		// faz primeiro movimento
		temp = ((int) (Math.random() * nodo.getQtdeFilhos()));
		Nodo ultimoMovimentoValido = nodo.copiarSemPai();
		Nodo nodoTemp;
		nodo.mover(nodo.getMovimentosValidos()[temp]);
		// agora verifica a cada movimento se no  repetido.
		for (int i = 0; i < nJogadas; i++) {
			temp = ((int) (Math.random() * nodo.getQtdeFilhos()));
			nodoTemp = nodo.copiarSemPai(); // guarda tabuleiro atual...
			nodo.mover(nodo.getMovimentosValidos()[temp]);// faz movimento
			if (nodo.equals(ultimoMovimentoValido)) {// se movimento igual a
				// ultimo vlido...
				i--;// repete tentativa de movimento
				nodo = nodoTemp;
			} else {
				ultimoMovimentoValido = nodoTemp;
			}
			// System.out.println((i + 1)
			// + " movimento. Num. de possveis escolhas: "
			// + nodo.getQtdeFilhos() + ". Escolha feita: " + (temp + 1)
			// + ".");
			// imprime(nodo);
		}
		return nodo.copiarSemPai();
	}

	private static void imprime(Nodo nodo) {
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++)
				System.out.print(nodo.getPecaNoTabuleiro(i, j));
			System.out.print("\n");
		}
		System.out.print("\n");
	}

	private static void imprimeCaminho(Nodo nodo) {
		System.out.println("Caminho percorrido");
		Nodo fila[] = new Nodo[100];
		int controle = 0;
		Nodo nodoTemp = nodo;
		while (nodoTemp.getPai() != null) {
			fila[controle] = nodoTemp;
			nodoTemp = nodoTemp.getPai();
			controle++;
		}
		fila[controle] = nodoTemp;
		for (int i = controle; i >= 0; i--)
			imprime(fila[i]);
		System.out.print("\n");
	}

}
